<template>
  <dialog id="image-load-dialog">
    <div class="mdl-dialog__content">
      <p>
        Select image and start uploading  
      </p>
      <input
        @change="checkImageProperties" 
        type="file" 
        id="selected-image">
      <div
        v-if="$store.getters.isImageUploading" 
        id="loader" 
        class="mdl-progress mdl-js-progress">
      </div>
    </div>
    <div class="mdl-dialog__actions mdl-dialog__actions--full-width">
      <button 
        @click="UploadImage"
        type="button" 
        class="mdl-button">
        Upload
      </button>
      <button
        @click="$store.commit('closeDialog', getImageLoadDialogELement())" 
        type="button" 
        class="mdl-button">
        Cancel
      </button>
    </div>
  </dialog>
</template>

<script>
import Dialog from './Dialog';

export default {
	props: ['element'],
	data() {
		return {
			isAnyError: null,
		};
	},
	components: {
		Dialog,
	},
	methods: {
		getImageLoadDialogELement() {
			return document.querySelector('#image-load-dialog');
		},
		UploadImage() {
			let self = this;
			if (this.isAnyError) {
				this.$store.commit('showSnackbar', this.isAnyError);
				return false;
			}
			this.$store
				.dispatch(
					'UploadImage',
					document.querySelector('#selected-image').files[0]
				)
				.then(function(res) {
					self.$store.commit('addImageToImageList', res.data);
					self.$store.commit('showSnackbar', 'Image upload success');
				})
				.catch(function(err) {
					console.log(err);
					self.isAnyError = err.data;
					self.$store.commit(
						'showSnackbar',
						'An error handle wile image uploading'
					);
				});
		},
		checkImageProperties() {
			let self = this;
			this.isAnyError = false;
			let file = document.querySelector('#selected-image').files[0];
			let validExtension = /\.(png|jpeg|jpg|gif)$/i;
			if (!validExtension.test(file.name)) {
				self.$store.commit('showSnackbar', 'Unsupported file extension');
				this.isAnyError = 'Unsupported file extension';
			}
			let reader = new FileReader();
			reader.readAsDataURL(file);
			reader.onload = function(event) {
				let image = new Image();
				image.src = event.target.result;
				image.onload = function() {
					if (this.width < 600) {
						self.$store.commit(
							'showSnackbar',
							'Unsupported Image size, minimal width is 600px'
						);
						self.isAnyError = 'Unsupported Image size, minimal width is 600px';
						return false;
					} else if (this.height < 600) {
						self.$store.commit(
							'showSnackbar',
							'Unsupported Image size, minimal height is 600px'
						);
						self.isAnyError = 'Unsupported Image size, minimal height is 600px';
						return false;
					}
					return true;
				};
			};
		},
	},
};
</script>
